// -*- MaTX -*-

// sim00008.mm: tmd00008.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/06/03>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00008.mm,v 1.2 1999/06/15 13:46:31 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00008_USER_H "sim00008.h"
#define TMD00008_USER_MM "sim00008.mm"

// TMD00008_USER_H  #include 롣
#include "tmd00008.h"


Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

  init_tmd00008(1); // Υߥ졼
//  init_tmd00008(0); // Υߥ졼(not given)

  {TC, XC, UC} = Ode45Auto(0.0, 10.0,
#ifndef TMD00008_USER_DIFF
			   [0.0, 0.0]',
#else /* TMD00008_USER_DIFF */
			   [[0.0, 0.0],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00008_USER_DIFF */
			   diff_tmd00008, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"x1(=xa)", "x2(=xd)", // XC
#ifdef TMD00008_USER_DIFF
	   "(x3)", "(x4)",  // ưŪξ
#endif /* TMD00008_USER_DIFF */
	   "u1(=delta_Gaast)", "u2(=w)", "y(=delta_Neast)" // UC
	   };

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      running = 1;
      uy = Z(TMD00008_DIM_ALL_IOS,1);
      u = chop_input_tmd00008(uy);
    }

  x = chop_state_tmd00008(xx);
  y = output_tmd00008(t, x, u);

  u(1) = 1.0;
  u(2) = 0.0;

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00008_USER_ODEXY_UPTO_L
// ߡν(ֶ [0,L) ξ/ {x, uy} Ϳ롣)
Func List
TMD00008_USER_ODEXY_UPTO_L(t)
     Real t;
{
  Matrix x, u;

  if (t >= tmd00008(L))
    {
      error("TMD00008_USER_ODEXY_UPTO_L(): Incorrect argument. (t=%f>=L)\n", t);
    }

  x = [sin(t), sin(2.0*t)]';
  u = [cos(t), cos(2.0*t)]';
  return {x, u};
}
#endif /* TMD00008_USER_ODEXY_UPTO_L */


#ifdef TMD00008_USER_DIFF
// ߡưŪ
Func Matrix
TMD00008_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00008(xx);
  z = chop_other_state_tmd00008(xx);
  u = chop_input_tmd00008(uu);
  y = output_tmd00008(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00008_USER_DIFF */
