/* -*- MaTX -*-
 *
 * tmd00008.mm: TMD No. tmd00008 ư֤Υɥž
 *
 *  Originally written by KIYOTA Hiromitsu <1999/06/03>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00008.mm,v 1.4 1999/07/02 22:51:27 kiyota Exp $
 */

#ifndef _TMD00008_MM
#define _TMD00008_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00008.h"

// some definitions for local alist
#ifndef TMD00008_DISABLE_HALIST
#define _TMD_LALIST {"_tmd00008"}
#define _TMD_LIN_FLAG "linear_flag"
#define _TMD_DIFF_RUNNING "diff_running"
#define _TMD_DIFF_XX0 "diff:_xx0"
#define _TMD_DIFF_UU0 "diff:_uu0"
#endif /* ! TMD00008_DISABLE_HALIST */

// just for simplicity... B)
#define tmd08(var) tmd00008(var)

Func void
init_tmd00008(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00008_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00008_DISABLE_HALIST */
  Polynomial s;
  Matrix Ga_tfm, Gd_tfm;

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 1; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00008(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

#ifndef TMD00008_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  // ()Υե饰
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}});
  
  // formerly (static Integer) running in diff_tmd00008()
  halist(_TMD_LALIST, {{_TMD_DIFF_RUNNING, 0}});
#else /* TMD00008_DISABLE_HALIST */
  tmd00008_flag = linear_flag;
#endif /* ! TMD00008_DISABLE_HALIST */

  if (params_flag == 0)
    {
      tmd08(Vm) = 1.0; /* m^3 */	// ۵
      tmd08(Vh) = 1.0; /* m^3 */	// 
      tmd08(etav) = 1.0;	// ѸΨ
      tmd08(J) = 1.0;	// ⡼
      tmd08(c) = 1.0;	// 񹳷

      tmd08(etavo) = 1.0;
      tmd08(Neo) = 120.0;
      tmd08(Pbo) = 1.0;
      tmd08(Gao) = 1.0;
    }

  tmd08(taua) = 120.0*tmd08(Vm)/(tmd08(etavo)*tmd08(Neo)*tmd08(Vh));
  tmd08(Kp) = 1.0; /* deltaT*tmd08(Pbo)/delta_Pb ?? */
  tmd08(Kd) = tmd08(c)*PI*tmd08(Neo)/30.0;
  tmd08(taud) = tmd08(J)/tmd08(c);
  tmd08(L) = 120.0/tmd08(Neo); /* s */	// ۵ǳƤޤǤ٤
  
  s = Polynomial("s");
  Ga_tfm = [1.0/(1.0 + tmd08(taua)*s)];
  Gd_tfm = [1.0/(tmd08(Kd)*(1.0 + tmd08(taud)*s))];
  {tmd08(Aa),tmd08(Ba),tmd08(Ca),tmd08(Da)} = tfm2ss(Ga_tfm);
  {tmd08(Ad),tmd08(Bd),tmd08(Cd),tmd08(Dd)} = tfm2ss(Gd_tfm);

  if (tmd08(Da) != Z(tmd08(Da)) || tmd08(Dd) != Z(tmd08(Dd)))
    {
      print tmd08(Da), tmd08(Dd);
      error("init_tmd00008(): Input-direct terms (D) must be zero matrices in this implementation.\n");
      // This restriction is for the simplicity of implementation.
      // It allows us to implement this model as self-contained only in
      // diff_tmd00008().  It is useful in some senses. ;)

      // Btw, can we use OdeXY() normally in the case of nesting solver
      // Ode*() ??  Maybe not. (heard from Koga-san)
    }
}


Func Matrix
diff_tmd00008(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix dxx;
#ifdef TMD00008_USER_ODEXY_UPTO_L
  List TMD00008_USER_ODEXY_UPTO_L();
#else /* ! TMD00008_USER_ODEXY_UPTO_L */
#ifdef TMD00008_DISABLE_HALIST
  static Integer running;
  static Matrix xx0, uu0;
#endif /* TMD00008_DISABLE_HALIST */
#endif /* TMD00008_USER_ODEXY_UPTO_L */
#ifndef TMD00008_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00008_DISABLE_HALIST */
  Matrix dx, x, u;
#ifdef TMD00008_USER_DIFF
  Matrix TMD00008_USER_DIFF();
#endif /* TMD00008_USER_DIFF */
  Matrix xa, xd, x_L, u_L, xa_L;
  Real delta_Gaast, w, delta_Neast, delta_Pbast_L, T;

#ifndef TMD00008_USER_ODEXY_UPTO_L
#ifndef TMD00008_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_DIFF_RUNNING}) == {0}) // when the first time
    {
      halist(_TMD_LALIST, {{_TMD_DIFF_RUNNING, 1},
			   {_TMD_DIFF_XX0, xx}, // ֤¸
			   {_TMD_DIFF_UU0, uu}}); // Ϥ¸
    }
#else /* TMD00008_DISABLE_HALIST */
  if (running == 0) // /Ϥ¸
    {
      running = 1;
      {xx0, uu0} = {xx, uu};
    }
#endif /* ! TMD00008_DISABLE_HALIST */
#endif /* ! TMD00008_USER_ODEXY_UPTO_L */

  x = chop_state_tmd00008(xx);
  u = chop_input_tmd00008(uu);

#if 0
#ifndef TMD00008_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00008_DISABLE_HALIST */
  if (tmd00008_flag == 0) // ǥ
#endif /* ! TMD00008_DISABLE_HALIST */
    {
      // not given
    }
  else // ǥ
    {
#endif /* 0 */
      xa = x(1:1); // Manifold (Ga_tfm)ξ
      xd = x(2:2); // Inertia (Gd_tfm)ξ
      delta_Gaast = u(1); // 줿̤ư
      w = u(2); // Torque Disturbance
      // delta_Neast in this form: critically dependent upon Dd == 0
      delta_Neast = [tmd08(Cd)*xd](1); // 줿ɥžư
      if (t >= tmd08(L))
	{
	  if (tmd08(L) > 0.0)
	    {
	      {x_L, u_L} = OdeXY(t - tmd08(L));
	    }
	  else
	    {
	      {x_L, u_L} = {xx, uu};
	    }
	}
      else
	{
#ifdef TMD00008_USER_ODEXY_UPTO_L
	  {x_L, u_L} = TMD00008_USER_ODEXY_UPTO_L(t);
#else /* ! TMD00008_USER_ODEXY_UPTO_L */
#ifndef TMD00008_DISABLE_HALIST
	  {x_L, u_L} = halist(_TMD_LALIST, {_TMD_DIFF_XX0, _TMD_DIFF_UU0});
#else /* TMD00008_DISABLE_HALIST */
	  {x_L, u_L} = {xx0, uu0};
#endif /* ! TMD00008_DISABLE_HALIST */
#endif /* TMD00008_USER_ODEXY_UPTO_L */
	}
      {x_L, u_L} = {chop_state_tmd00008(x_L), chop_input_tmd00008(u_L)};
      xa_L = x_L(1:1);
      // delta_Pbast_L in this form: critically dependent upon Da == 0
      delta_Pbast_L = [tmd08(Ca)*xa_L](1); // L 줿۵ⰵ
      T = tmd08(Kp)*delta_Pbast_L;

      dx = [[tmd08(Aa)*xa + tmd08(Ba)*(delta_Gaast - delta_Neast)]
	    [tmd08(Ad)*xd + tmd08(Bd)*(T + w)]];
#if 0
    }
#endif /* 0 */

  dxx = [[dx]
#ifdef TMD00008_USER_DIFF
	 [TMD00008_USER_DIFF(t, xx, uu)]
#endif /* TMD00008_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00008(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, u, y;
  Matrix xd, ud;

  x = chop_state_tmd00008(xx);
  u = chop_input_tmd00008(uu);

  xd = x(2:2); // Inertia (Gd_tfm)ξ
  // y in this form: critically dependent upon Dd == 0
  y = tmd08(Cd)*xd;
  return y;
}


#undef tmd08
#ifndef TMD00008_DISABLE_HALIST
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG
#undef _TMD_DIFF_RUNNING
#undef _TMD_DIFF_XX0
#undef _TMD_DIFF_UU0
#endif /* ! TMD00008_DISABLE_HALIST */

#endif /* !_TMD00008_MM */
